import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.HashSet;

import java.util.Map;
import java.util.SortedMap;
import java.util.HashMap;
import java.util.TreeMap;

import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;

public class MapOfSetDemo {
    
    private Map<Person, Set<Person>> school;
    
    public MapOfSetDemo() {
        school = new HashMap<>();
    }
    
    public Collection<Person> getPupils(Person teacher) {
        return Collections.unmodifiableCollection(
           school.get(teacher));
    }
    
    public void addTeacher(Person t) {
        school.put(t, new TreeSet<Person>());
    }
    
    public void removeTeacher(Person t) {
        school.remove(t);
    }
    
    public void addPupil(Person teacher, Person pupil){
        Set<Person> pupils = school.get(teacher);
        if(pupils != null) {
            pupils.add(pupil);
        }
    }
    
    public void removePupil(Person teacher, Person pupil){
        Set<Person> pupils = school.get(teacher);
        if(pupils != null) {
            pupils.remove(pupil);
        }
    }
    
    public static void main(String[] args)
    {
        MapOfSetDemo d = new MapOfSetDemo();
        
        Person novak = new Person("Jan Novak", "1980/11/20");
        d.addTeacher(novak);
        d.addTeacher(new Person("Pavel Novotny", "1970/11/20"));
        d.addTeacher(new Person("Ales Vacha", "1960/11/20"));
        
        d.addPupil(novak, new Person("Pupil 1", "2000/11/30"));
        d.addPupil(novak, new Person("Pupil 2", "2002/11/30"));
        
        for(Map.Entry<Person, Set<Person>> me: d.school.entrySet() ) {
            System.out.println("Entry "+me.getKey()+"=>"+me.getValue());
        }
        
     }

}
class DateOfBirthComparator implements Comparator<Person> {
    public int compare(Person a, Person b) {
        int comp = a.getDate().compareTo(b.getDate());
        if(comp == 0) {
            return a.getName().compareTo(b.getName());
        } else return comp;
    }
}
class DateOfBirthComparatorDescending extends DateOfBirthComparator {
    public int compare(Person a, Person b) {
        return -super.compare(a, b);
    }
}

class Person implements Comparable<Person> {
    private String name;
    private String date;
    public Person(String name, String date) { this.name = name; this.date = date; }
    public String toString() { return name+" born "+date; }
    public int compareTo(Person p) {
        int comp = name.compareTo(p.name);
        if(comp == 0) {
            return date.compareTo(p.date);
        } else return comp;
    }
    public boolean equals(Object obj) {
        if(obj instanceof Person) {
            Person p = (Person)obj;
            return name.equals(p.name) && date.equals(p.date);
        } else return false;
    }
    public int hashCode() {
        return name.hashCode() ^ date.hashCode();
    }
    public String getDate() { return date; }
    public String getName() { return name; }
}